Package net.sf.saxon.expr.instruct

## Class ComputedElement

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.ParentNodeConstructor
      - - net.sf.saxon.expr.instruct.ElementCreator
        - - net.sf.saxon.expr.instruct.ComputedElement

- All Implemented Interfaces:
    `ExportAgent`, `InstructionWithComplexContent`, `TailCallReturner`, `ValidatingInstruction`, `Locatable`, `IdentityComparable`, `Traceable`

      public class ComputedElement
      extends ElementCreator

  An instruction representing an xsl:element element in an XSLT stylesheet, or a computed element constructor in XQuery. (In both cases, if the element name is expressed as a compile-time expression, then a FixedElement instruction is used instead.)
  See Also:
    `FixedElement`

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor

      `contentOp, preservingTypes`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ComputedElement​(Expression elementName, Expression namespace, SchemaType schemaType, int validation, boolean inheritNamespaces, boolean allowQName)` | Create an instruction that creates a new element node

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `checkPermittedContents​(SchemaType parentType, boolean whole)` | Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `NodeName` | `getElementName​(XPathContext context, NodeInfo copiedNode)` | Callback from the superclass ElementCreator to get the nameCode for the element name
    `int` | `getInstructionNameCode()` | Get the name of this instruction for diagnostic and tracing purposes
    `ItemType` | `getItemType()` | Get the item type of the value returned by this instruction
    `Expression` | `getNameExp()` | Get the expression used to compute the element name
    `Expression` | `getNamespaceExp()` | Get the expression used to compute the namespace URI
    `NamespaceResolver` | `getNamespaceResolver()` | Get the namespace resolver that provides the namespace bindings defined in the static context
    `java.lang.String` | `getNewBaseURI​(XPathContext context, NodeInfo copiedNode)` | Get the base URI for the element being constructed
    `boolean` | `isAllowNameAsQName()` | Ask whether the name can be supplied as a QName.
    `java.lang.Iterable<Operand>` | `operands()` | Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression.
    `void` | `outputNamespaceNodes​(Outputter out, NodeName nodeName, NodeInfo copiedNode)` | Callback to output namespace nodes for the new element.
    `protected void` | `setNameExp​(Expression elementName)` |
    `protected void` | `setNamespaceExp​(Expression namespace)` |
    `Expression` | `simplify()` | Simplify an expression.
    `Expression` | `typeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | Perform type checking of an expression and its subexpressions.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.ElementCreator

      `checkContentSequence, computeSpecialProperties, getCardinality, getImplementationMethod, getStreamerName, isBequeathNamespacesToChildren, isInheritNamespacesFromParent, processLeavingTail, processLeavingTail, setBequeathNamespacesToChildren, setInheritanceFlags, setInheritNamespacesFromParent, suppressValidation`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor

      `addToPathMap, allowExtractingCommonSubexpressions, alwaysCreatesNewNodes, computeCardinality, getContentExpression, getContentOperand, getSchemaType, getValidationAction, getValidationOptions, isLocal, isPreservingTypes, mayCreateNewNodes, optimize, setContentExpression, setNoNeedToStrip, setValidationAction`

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, evaluateItem, getExpressionName, getNetCost, getSourceLocator, isInstruction, isXSLT, iterate, process, someOperandCreatesNewNodes`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, checkedOperands, checkForUpdatingSubexpressions, computeDependencies, computeHashCode, computeStaticProperties, dynamicError, effectiveBooleanValue, equals, evaluatePendingUpdates, explain, getConfiguration, getCost, getDependencies, getEvaluationMethod, getExtraProperty, getIntegerBounds, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getStaticUType, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, markTailFunctionCalls, operandList, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplifyChildren, staticTypeCheck, toPattern, toShortString, toString, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Constructor Detail

    - #### ComputedElement

          public ComputedElement​(Expression elementName,
                                 Expression namespace,
                                 SchemaType schemaType,
                                 int validation,
                                 boolean inheritNamespaces,
                                 boolean allowQName)

      Create an instruction that creates a new element node
      Parameters:
        `elementName` - Expression that evaluates to produce the name of the element node as a lexical QName
        `namespace` - Expression that evaluates to produce the namespace URI of the element node. Set to null if the namespace is to be deduced from the prefix of the elementName.
        `schemaType` - The required schema type for the content
        `validation` - Required validation mode (e.g. STRICT, LAX, SKIP)
        `inheritNamespaces` - true if child elements automatically inherit the namespaces of their parent
        `allowQName` - True if the elementName expression is allowed to return a QNameValue; false if

  - ### Method Detail

    - #### getNameExp

          public Expression getNameExp()

      Get the expression used to compute the element name
      Returns:
        the expression used to compute the element name

    - #### getNamespaceExp

          public Expression getNamespaceExp()

      Get the expression used to compute the namespace URI
      Returns:
        the expression used to compute the namespace URI

    - #### setNameExp

          protected void setNameExp​(Expression elementName)

    - #### setNamespaceExp

          protected void setNamespaceExp​(Expression namespace)

    - #### operands

          public java.lang.Iterable<Operand> operands()

      Description copied from class: `Expression`
      Get the immediate sub-expressions of this expression, with information about the relationship of each expression to its parent expression. Default implementation works off the results of iterateSubExpressions()

      If the expression is a Callable, then it is required that the order of the operands returned by this function is the same as the order of arguments supplied to the corresponding call() method.

      Specified by:
        `operands` in class `Instruction`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### getNamespaceResolver

          public NamespaceResolver getNamespaceResolver()

      Get the namespace resolver that provides the namespace bindings defined in the static context
      Returns:
        the namespace resolver

    - #### simplify

          public Expression simplify()
                              throws XPathException

      Description copied from class: `Expression`
      Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation simplifies its operands.
      Overrides:
        `simplify` in class `Expression`
      Returns:
        the simplified expression (or the original if unchanged, or if modified in-situ)
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### typeCheck

          public Expression typeCheck​(ExpressionVisitor visitor,
                                      ContextItemStaticInfo contextInfo)
                               throws XPathException

      Description copied from class: `Expression`
      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      Overrides:
        `typeCheck` in class `ParentNodeConstructor`
      Parameters:
        `visitor` - an expression visitor
        `contextInfo` - Information available statically about the context item: whether it is (possibly) absent; its static type; its streaming posture.
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - a mutable list of (old binding, new binding) pairs that is used to update the bindings held in any local variable references that are copied.
      Returns:
        the copy of the original expression

    - #### getItemType

          public ItemType getItemType()

      Get the item type of the value returned by this instruction
      Overrides:
        `getItemType` in class `ElementCreator`
      Returns:
        the item type

    - #### checkPermittedContents

          public void checkPermittedContents​(SchemaType parentType,
                                             boolean whole)
                                      throws XPathException

      Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.
      Overrides:
        `checkPermittedContents` in class `Expression`
      Parameters:
        `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
        `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
      Throws:
        `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

    - #### getElementName

          public NodeName getElementName​(XPathContext context,
                                         NodeInfo copiedNode)
                                  throws XPathException

      Callback from the superclass ElementCreator to get the nameCode for the element name
      Specified by:
        `getElementName` in class `ElementCreator`
      Parameters:
        `context` - The evaluation context (not used)
        `copiedNode` - Not applicable to this overload
      Returns:
        the name code for the element name
      Throws:
        `XPathException` - if a failure occurs

    - #### isAllowNameAsQName

          public boolean isAllowNameAsQName()

      Ask whether the name can be supplied as a QName. In practice this is true for XQuery, false for XSLT
      Returns:
        true if the name can be supplied as a QName

    - #### getNewBaseURI

          public java.lang.String getNewBaseURI​(XPathContext context,
                                                NodeInfo copiedNode)

      Description copied from class: `ElementCreator`
      Get the base URI for the element being constructed
      Specified by:
        `getNewBaseURI` in class `ElementCreator`
      Parameters:
        `context` - the XPath dynamic evaluation context
        `copiedNode` - the node being copied (for xsl:copy), otherwise null
      Returns:
        the base URI of the constructed element

    - #### outputNamespaceNodes

          public void outputNamespaceNodes​(Outputter out,
                                           NodeName nodeName,
                                           NodeInfo copiedNode)
                                    throws XPathException

      Callback to output namespace nodes for the new element.
      Specified by:
        `outputNamespaceNodes` in class `ElementCreator`
      Parameters:
        `out` - the Outputter where the namespace nodes are to be written
        `nodeName` - The name of the element node being output
        `copiedNode` - Where this is a copied node, the node being copied
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction for diagnostic and tracing purposes
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Specified by:
        `export` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.